#GRL Estimation

rm(list=ls(all=TRUE))
setwd("C:/Users/bin/Desktop/assignment")
#theta<-0.000000572904
theta<-0.000000572904
#binit <- c(0,0,0) # initial value of the parameter

x<-c(-0.003589,-0.1853426, -14.372546)# initial value of the parameter length, right, lane

#inputdatapass<-"Trip.csv"
inputlinkpass<-"network/reduced_link_t.csv"
inputmatrixpass<-"network/reduced_matrix.csv"
inputRigthpass<-"network/reduced_rightturn.csv"

demandpass<-"reduced_bike_ODdemand.csv"

# inputRigthpass<-"C:/Rworkspace/reduced_rightturn.csv"

readdata.number <- -1 # -1 = all
#samplingdummy <- 0 # 1 = sampling , 0 = all
#sampling.numbaer <- 100

############### time measure ############
#message("PROGRAM START!\n")
#t<-proc.time()


#########################################
########  reading & sampling    #########
#########################################


########## result data reading ##########
#data <- read.csv(inputdatapass, nrows = readdata.number)
#names(data) <- c("k","a","d")

#------------------------------------------------------------------------------------------------------------------------------------------------------------

#ddata <- sort(unique(data$d))     # sort destinations
#kdata <- list()                   # empty list
#dataList <- list()                # empty list
#for(i in 1:length(ddata)){
#sub <- subset(data,data$d == ddata[i])        # subsetting of "data" w.r.t to each OD pair
#kdata[[i]] <- sort(unique(sub$k))             # sort each subset according to current link k (load list)
#dataList[[i]] <- sub                          # load each OD pair subset in list
#print(dataList)
#}

##########Demand data reading ######

data<-read.csv(demandpass, nrows=readdata.number)
names(data) <- c("o","d","demand")
ddata <- sort(unique(data$d))
odata <- sort(unique(data$o))


########## link data reading ############
link <- read.csv(inputlinkpass)
linkid <- sort(unique(link$LinkID))
L <- length(linkid)

##
if(any(link$Speed == 0))
  link$Speed[link$Speed == 0] <- 1
#print(link$Speed)


########## link matrix reading ##########
matrix <- read.csv(inputmatrixpass)
names(matrix) <- c("k","a")
asetdataList <-list()
matrixList <- list()


#
AList <- list()
for(k in 1:L){
  kl <- linkid[k]
  sub <- subset(matrix, matrix$k == kl)
  AList[[k]] <- sub$a                           # sets of oytgoing links from given link k is seperated in list
}

################# index #################
dlength <- length(ddata)                # No. of OD pair
llength <- length(link$LinkID)          # No. of links
D <- length(unique(data$d))             # Length of unique OD pair
L <- length(linkid)                     # No. of links

#------------------------------------------------------------------------------------------------------------------------------------------------------------
######### link connectiuon dummy ########
I <- array(0, dim = c(L, L))
names(matrix) <- c("k","a")

#for (g in 1:D) {

for(i in 1:nrow(matrix)){
  kl <- matrix$k[i]
  al <- matrix$a[i]
  k <- (1:length(linkid))[linkid == kl]
  a <- (1:length(linkid))[linkid == al]
  I[k,a] <- 1                                   # Link connection incidence matrix
}
Ilist <- list()
for(d in 1:D){                                  # for d in no no. of destinations
  dl <- ddata[d]
  #print(ddata[d]) # Mage weda
  #print(is.na(ddata[d])) # Mage weda
  
  dn<-(1:length(linkid))[linkid == dl]
  #
  Id <- I
  #
  Id[dn, ] <- 0
  #print(Id) # Mage weda
  #
  for(k in 1:L){
    aList <- AList[[k]]
    if(is.element(dl, aList)){
      Id[k, ] <- 0
      Id[k, dn] <- 1
      #print(Id) # Mage weda
    }
  }
  Ilist[[d]] <- Id
}
#}
#------------------------------------------------------------------------------------------------------------------------------------------------------------
#################right####################
Right <- read.csv(inputRigthpass,header=T) #, header=F
names(Right) <- c("k","a")
RR <- array(exp(0), dim = c(L, L))
for(s in 1:nrow(Right)){
  kl <- Right$k[s]
  al <- Right$a[s]
  k<-(1:length(linkid))[linkid == kl]
  a<-(1:length(linkid))[linkid == al]
  RR[k,a] <- exp(1)
}

##################Length####################
#tt <- array(exp(0), dim = c(1, L))
#for(a in 1:L){
#  tt[1,a] <- exp(0.6*(link$Length[a]))
#  # tt[1,a] <- exp(0.6*(link$Length[a]/link$Speed[a]))
#}
#TT <- array(rep(tt), dim = c(L, L))
##TT <- matrix(rep(tt), nrow = L, ncol = L) 
#TT <- t(TT)
#
##################Lane####################
#la <- array(exp(0), dim = c(1, L))
#for(a in 1:L){
#  la[1,a] <- exp(link$Lane[a])
#  # tt[1,a] <- exp(0.6*(link$Length[a]/link$Speed[a]))
#}
#LA <- array(rep(la), dim = c(L, L))
##TT <- matrix(rep(tt), nrow = L, ncol = L) 
#LA <- t(LA)



#########################################
############ value function #############
#########################################
# newV <- function(x) {
#theta <- exp(x[3])/(1+exp(x[3])) #


z <- matrix(1, nrow = L, ncol = D) #exp(Vd)
#V <- array(0, dim = c(L, D))
#i <- 0
plist<-list()
logsum <- 0
id<-diag(L)

for (d in 1:D){
  kd <- (1:length(linkid))[linkid == ddata[d]] #####d
  z[kd, d] <- 1                                #####d
  
  M <- matrix(0, nrow = L, ncol = L) #
  B <- matrix(0, nrow = L, ncol = 1) #
  B[kd, 1] <- 1                      #d    destination link is 1
  
  #
  Id <- Ilist[[d]] #d              
  
  #
  for (k in 1:L){
    for (a in 1:L){
      Ika <- Id[k, a]
      if(Ika == 1){
        if(a == kd){
          M[k, a] <- 1 #
        }else{
          #M[k, a] <- exp(-1.5*(link$Length[a]))
          #M[k, a] <- exp(x[1]*0.6*(link$Length[a])+x[3]*(link$Lane[a]))*(RR[k,a]^x[2])
          M[k, a] <- exp(x[1]*0.6*(link$Length[a]))*(RR[k,a]^x[2])*exp(x[3]*(link$traffic[a]))
          
          
        }
      }
    }
  } 
  
  #------------------------------------------------------------------------------------------------------------------------------------------------------------
  # Estimation of choice probabilities
  dL <- 100
  zi <- matrix(z[,d], nrow = L, ncol = 1)
  while(dL > 0.01){
    zii <- zi
    Xz <- (zii)^theta
    zi <- M %*% Xz + B
    dL <- sum(abs(zii - zi))
    i <- i + 1
  } #while
  
  zi <- (zi==0)*1 + (zi!=0)*zi
  
  z[,d] <- zi
  
  PLM<-matrix(0,nrow=L, ncol=L) # Link probability matrix
  PL<-list()                    # list for PLM
  for(n in 1:nrow(M)){
    
    if(M[n,]%*%z[,d]>0){             # to avoid infinity value in calculation
      
      tr<-M[n,]*t(z[,d])
      do<-matrix(rep((M[n,]%*%z[,d])), nrow=1, ncol = L)
      Prob= tr/do
    }
    PL[[n]]=Prob
    PLM[n,]<-PL[[n]]
    
    for(r in 1:D){
      kg<-(1:length(linkid))[linkid == ddata[r]]            # set 0 probabability for destination to destination
      PLM[kg,]<-0 
      
    }
    #p<-length(kdata[[d]])
    
    k<-ddata[[d]]
    
    for (m in 1:nrow(M)) {
      p<-AList[[m]]
      
      
      if(is.element(k,p)){
        PLM[m,kd]<-0.99                                       # set 0 probability of extra links to destination
      } else
      {
        PLM[m,kd]<-0
      }
    }
  }
  
  #rownames(PLM)<-as.character(linkid)
  #colnames(PLM)<-as.character(linkid)
  
  #plist[[d]]<-PLM
  
  
  #print(plist)
  #------------------------------------------------------------------------------------------------------------------------------------------------------------
  
  ######### Link Flow Estimation ############
  
  #flist<-list()
  #id<-diag(L)
  
  #logsum <- 0
  
  #for (b in 1:D){
  
  #mt<-as.matrix(plist[[b]])
  mt<-as.matrix(PLM)
  In<-(id-t(mt))
  #so<-solve(In)
  
  v<-matrix(0, nrow=L, ncol=1)
  
  for (c in 1:nrow(data)) {
    
    t <- data$d[c]
    if(ddata[d]==t) {
      n <- data$o[c]
      y<- (1:length(linkid))[linkid==n]
      v[y,1]<-data$demand[c]
      
      ### logsum calcuration
      logsum <- logsum + log(z[y,d]) # value function
      
    }
    
  }
  
  #flow<-so%*%v
  #flist[[b]]<-flow
  
}

# sum of link flows for multiple destinations

#fv <- matrix(0, nrow= L, ncol=1)

#for (g in 1:length(flist)){
#  
#  fv<-fv+flist[[g]]
#  rownames(fv)<-as.character(linkid)
#  
#}
options("scipen"=1000, "digits"=0)
#print(fv)

print(logsum)

#------------------------------------------------------------------------------------------------------------------------------------------------------------

#write.csv(fv, "C:/Users/user/Desktop/assignment/car_assignment.csv", col.names = F, quote = F)
